Index: branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecCu.cpp	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecCu.cpp	(revision 97)
@@ -705,4 +705,15 @@
                                      m_pcPrediction->getPredicBufHeight (),
                                      bAboveAvail, bLeftAvail );
+#if LGE_EDGE_INTRA
+  if( uiLumaPredMode >= EDGE_INTRA_IDX )
+  {
+	  m_pcPrediction->predIntraLumaEdge( pcCU, pcCU->getPattern(), uiAbsPartIdx, uiWidth, uiHeight, piPred, uiStride
+#if LGE_EDGE_INTRA_DELTA_DC
+		  , uiLumaPredMode == EDGE_INTRA_DELTA_IDX
+#endif
+		  );
+  } 
+  else
+#endif
   
   //===== get prediction signal =====
Index: branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 97)
@@ -98,4 +98,10 @@
 , m_cDmmDataSCModel           ( 1,             1,               NUM_DMM_DATA_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
 #endif
+#if LGE_EDGE_INTRA
+, m_cEdgeIntraSCModel         ( 1,             1,               NUM_EDGE_INTRA_CTX            , m_contextModels + m_numContextModels, m_numContextModels)
+#if LGE_EDGE_INTRA_DELTA_DC
+, m_cEdgeIntraDeltaDCSCModel  ( 1,             1,               NUM_EDGE_INTRA_DELTA_DC_CTX   , m_contextModels + m_numContextModels, m_numContextModels)
+#endif
+#endif
 {
   assert( m_numContextModels <= MAX_NUM_CTX_MOD );
@@ -182,4 +188,10 @@
 
   m_cCUTransSubdivFlagSCModel.initBuffer ( sliceType, qp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
+#if LGE_EDGE_INTRA
+  m_cEdgeIntraSCModel.initBuffer         ( sliceType, qp, (UChar*)INIT_EDGE_INTRA );
+#if LGE_EDGE_INTRA_DELTA_DC
+  m_cEdgeIntraDeltaDCSCModel.initBuffer  ( sliceType, qp, (UChar*)INIT_EDGE_INTRA_DELTA_DC );
+#endif
+#endif
   m_uiLastDQpNonZero  = 0;
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
@@ -850,4 +862,14 @@
 #endif
   
+#if LGE_EDGE_INTRA
+  Bool bCodeEdgeIntra = false;
+  if( pcCU->getSlice()->getSPS()->isDepth() )
+  {
+	  UInt uiPUWidth = pcCU->getWidth( uiAbsPartIdx ) >> (pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_NxN ? 1 : 0);
+	  if( uiPUWidth <= LGE_EDGE_INTRA_MAX_SIZE && uiPUWidth >= LGE_EDGE_INTRA_MIN_SIZE )
+		  bCodeEdgeIntra = true;
+  }
+#endif
+
 #if LOGI_INTRA_NAME_3MPM
   Int uiPreds[3] = {-1, -1, -1};
@@ -855,5 +877,8 @@
   Int uiPreds[2] = {-1, -1};
 #endif
-  Int uiPredNum = pcCU->getIntraDirLumaPredictor(uiAbsPartIdx, uiPreds);  
+  Int uiPredNum = pcCU->getIntraDirLumaPredictor(uiAbsPartIdx, uiPreds); 
+#if LGE_EDGE_INTRA
+  UInt uiCheckBit = 0;
+#endif
  
   m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUIntraPredSCModel.get( 0, 0, 0) );
@@ -878,4 +903,15 @@
    
     m_pcTDecBinIf->decodeBinsEP( uiSymbol, 5 );
+#if LGE_EDGE_INTRA
+	if (bCodeEdgeIntra)
+	{
+		if (uiSymbol==31)
+		{
+			m_pcTDecBinIf->decodeBinsEP(uiCheckBit,1);
+			if (uiCheckBit)
+				uiSymbol = EDGE_INTRA_IDX;
+		}
+	}
+#endif
     intraPredMode = uiSymbol;
     
@@ -903,9 +939,57 @@
     }
 #endif
+#if LGE_EDGE_INTRA
+	if ( intraPredMode != EDGE_INTRA_IDX)
+	{
+#endif
     for ( Int i = 0; i < uiPredNum; i++ )
     {
       intraPredMode += ( intraPredMode >= uiPreds[i] );
     }
-  }
+#if LGE_EDGE_INTRA
+	}
+#endif
+  }
+
+#if LGE_EDGE_INTRA
+  if( intraPredMode == EDGE_INTRA_IDX )
+  {
+	  xParseEdgeIntraInfo( pcCU, uiAbsPartIdx, uiDepth );
+#if LGE_EDGE_INTRA_DELTA_DC
+	  m_pcTDecBinIf->decodeBin( uiSymbol, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 0) );
+	  if( uiSymbol )
+	  {
+		  intraPredMode = EDGE_INTRA_DELTA_IDX;
+		  Int iDeltaDC0;
+		  Int iDeltaDC1;
+
+		  xReadExGolombLevel( (UInt &) iDeltaDC0, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
+		  if( iDeltaDC0 != 0 )
+		  {
+			  UInt uiSign;
+			  m_pcTDecBinIf->decodeBinEP( uiSign );
+			  if ( uiSign )
+			  {
+				  iDeltaDC0 = -iDeltaDC0;
+			  }
+		  }
+		  xReadExGolombLevel( (UInt &) iDeltaDC1, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
+		  if( iDeltaDC1 != 0 )
+		  {
+			  UInt uiSign;
+			  m_pcTDecBinIf->decodeBinEP( uiSign );
+			  if ( uiSign )
+			  {
+				  iDeltaDC1 = -iDeltaDC1;
+			  }
+		  }
+
+		  pcCU->setEdgeDeltaDC0( uiAbsPartIdx, iDeltaDC0 );
+		  pcCU->setEdgeDeltaDC1( uiAbsPartIdx, iDeltaDC1 );
+	  }
+#endif
+  }
+#endif
+
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
   }
@@ -2012,5 +2096,5 @@
 #endif
 
-#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
+#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX || (LGE_EDGE_INTRA && LGE_EDGE_INTRA_DELTA_DC)
 Void TDecSbac::xReadExGolombLevel( UInt& ruiSymbol, ContextModel& rcSCModel  )
 {
@@ -2270,3 +2354,102 @@
 }
 #endif
+
+#if LGE_EDGE_INTRA
+Void TDecSbac::xParseEdgeIntraInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
+	UInt uiSymbol = 0;
+
+	// 1. Top(0) or Left(1)
+	UChar ucLeft;
+	m_pcTDecBinIf->decodeBinEP( uiSymbol );
+	ucLeft = uiSymbol;
+
+	// 2. Start position (lowest bit first)
+	UChar ucStart = 0;
+	for( UInt ui = 0; ui < 6 - uiDepth; ui++ )
+	{
+		m_pcTDecBinIf->decodeBinEP( uiSymbol );
+		ucStart |= (uiSymbol << ui);
+	}
+
+	// 3. Number of edges
+	UChar ucMax = 0;
+	for( UInt ui = 0; ui < 7 - uiDepth; ui++ )
+	{
+		m_pcTDecBinIf->decodeBinEP( uiSymbol );
+		ucMax |= (uiSymbol << ui);
+	}
+	ucMax++; // +1
+
+	// 4. Edges
+	UChar* pucSymbolList = (UChar*) xMalloc( UChar, 256 * LGE_EDGE_INTRA_MAX_EDGE_NUM_PER_4x4 );
+	UInt uiCtxEdgeIntra = pcCU->getCtxEdgeIntra( uiAbsPartIdx );
+	for( Int iPtr = 0; iPtr < ucMax; iPtr++ )
+	{
+		UChar ucEdge = 0;
+		UInt  uiReorderEdge = 0;
+		// Left-friendly direction
+		// 0 (   0deg) => 0
+		// 1 (  45deg) => 10
+		// 2 ( -45deg) => 110
+		// 3 (  90deg) => 1110
+		// 4 ( -90deg) => 11110
+		// 5 ( 135deg) => 111110
+		// 6 (-135deg) => 111111
+		// Right-friendly direction
+		// 0 (   0deg) => 0
+		// 1 ( -45deg) => 10
+		// 2 (  45deg) => 110
+		// 3 ( -90deg) => 1110
+		// 4 (  90deg) => 11110
+		// 5 (-135deg) => 111110
+		// 6 ( 135deg) => 111111
+		// refer to a paper "An efficient chain code with Huffman coding"
+		for( UInt ui = 0; ui < 6; ui++ )
+		{
+			m_pcTDecBinIf->decodeBin( uiSymbol, m_cEdgeIntraSCModel.get( 0, 0, uiCtxEdgeIntra ) );
+			ucEdge <<= 1;
+			ucEdge |= uiSymbol;
+			if( uiSymbol == 0 )
+				break;
+		}
+
+		switch( ucEdge )
+		{
+		case 0 :  // "0"
+			uiReorderEdge = 0;
+			break;
+		case 2 :  // "10"
+			uiReorderEdge = 1;
+			break;
+		case 6 :  // "110"
+			uiReorderEdge = 2;
+			break;
+		case 14 : // "1110"
+			uiReorderEdge = 3;
+			break;
+		case 30 : // "11110"
+			uiReorderEdge = 4;
+			break;
+		case 62 : // "111110"
+			uiReorderEdge = 5;
+			break;
+		case 63 : // "111111"
+			uiReorderEdge = 6;
+			break;
+		default :
+			printf("parseIntraEdgeChain: error (unknown code %d)\n",ucEdge);
+			assert(false);
+			break;
+		}
+		pucSymbolList[iPtr] = uiReorderEdge;
+	}
+	/////////////////////
+	// Edge Reconstruction
+	Bool* pbRegion = pcCU->getEdgePartition( uiAbsPartIdx );
+	pcCU->reconPartition( uiAbsPartIdx, uiDepth, ucLeft == 1, ucStart, ucMax, pucSymbolList, pbRegion );
+	xFree( pucSymbolList );
+}
+#endif
+
 //! \}
Index: branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecSbac.h	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibDecoder/TDecSbac.h	(revision 97)
@@ -145,4 +145,8 @@
   Void xParseContourPredTexDeltaInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
+
+#if LGE_EDGE_INTRA
+  Void xParseEdgeIntraInfo ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#endif
   
 private:
@@ -253,4 +257,10 @@
   ContextModel3DBuffer m_cDmmDataSCModel;
 #endif
+#if LGE_EDGE_INTRA
+  ContextModel3DBuffer m_cEdgeIntraSCModel;
+#if LGE_EDGE_INTRA_DELTA_DC
+  ContextModel3DBuffer m_cEdgeIntraDeltaDCSCModel;
+#endif
+#endif
 };
 
Index: branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 97)
@@ -106,4 +106,10 @@
 , m_cDmmDataSCModel           ( 1,             1,               NUM_DMM_DATA_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
 #endif
+#if LGE_EDGE_INTRA
+, m_cEdgeIntraSCModel         ( 1,             1,               NUM_EDGE_INTRA_CTX            , m_contextModels + m_numContextModels, m_numContextModels)
+#if LGE_EDGE_INTRA_DELTA_DC
+, m_cEdgeIntraDeltaDCSCModel  ( 1,             1,               NUM_EDGE_INTRA_DELTA_DC_CTX   , m_contextModels + m_numContextModels, m_numContextModels)
+#endif
+#endif
 {
   assert( m_numContextModels <= MAX_NUM_CTX_MOD );
@@ -181,4 +187,10 @@
   m_cDmmDataSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_DMM_DATA );
 #endif
+#if LGE_EDGE_INTRA
+  m_cEdgeIntraSCModel.initBuffer         ( eSliceType, iQp, (UChar*)INIT_EDGE_INTRA );
+#if LGE_EDGE_INTRA_DELTA_DC
+  m_cEdgeIntraDeltaDCSCModel.initBuffer  ( eSliceType, iQp, (UChar*)INIT_EDGE_INTRA_DELTA_DC );
+#endif
+#endif
 
   // new structure
@@ -828,4 +840,79 @@
   DTRACE_CABAC_T( "\n" )
 }
+
+#if LGE_EDGE_INTRA
+Void TEncSbac::xCodeEdgeIntraInfo( TComDataCU* pcCU, UInt uiPartIdx )
+{
+	UInt   uiDepth        = pcCU->getDepth( uiPartIdx ) + (pcCU->getPartitionSize( uiPartIdx ) == SIZE_NxN ? 1 : 0);
+	UInt   uiCtxEdgeIntra = pcCU->getCtxEdgeIntra( uiPartIdx );
+	UChar* pucSymbolList  = pcCU->getEdgeCode( uiPartIdx );
+	UChar  ucEdgeNumber   = pcCU->getEdgeNumber( uiPartIdx );
+	Bool   bLeft          = pcCU->getEdgeLeftFirst( uiPartIdx );
+	UChar  ucStart        = pcCU->getEdgeStartPos( uiPartIdx );
+	UInt   uiSymbol;
+
+	// 1. Top(0) or Left(1)
+	uiSymbol = (bLeft == false) ? 0 : 1;
+	m_pcBinIf->encodeBinEP( uiSymbol );
+
+	// 2. Start position (lowest bit first)
+	uiSymbol = ucStart;
+	for( UInt ui = 6; ui > uiDepth; ui-- ) // 64(0)->6, 32(1)->5, 16(2)->4, 8(3)->3, 4(4)->2
+	{
+		m_pcBinIf->encodeBinEP( uiSymbol & 0x1 );
+		uiSymbol >>= 1;
+	}
+
+	// 3. Number of edges
+	uiSymbol = ucEdgeNumber > 0 ? ucEdgeNumber - 1 : 0;
+	for( UInt ui = 7; ui > uiDepth; ui-- ) // 64(0)->7, 32(1)->6, 16(2)->5, 8(3)->4, 4(4)->3
+	{
+		m_pcBinIf->encodeBinEP( uiSymbol & 0x1 );
+		uiSymbol >>= 1;
+	}
+
+	if(uiSymbol != 0)
+	{
+		printf(" ucEdgeNumber %d at depth %d\n",ucEdgeNumber, uiDepth);
+		assert(false);
+	}
+
+	// 4. Edges
+	for( Int iPtr2 = 0; iPtr2 < ucEdgeNumber; iPtr2++ )
+	{
+		UInt uiReorderSymbol = pucSymbolList[iPtr2];
+
+		//printf ("Ptr = %d, Symbol = %d\n", iPtr2, uiSymbol);
+
+		// Left-friendly direction (Top start)
+		// 0 (   0deg) => 0
+		// 1 (  45deg) => 10
+		// 2 ( -45deg) => 110
+		// 3 (  90deg) => 1110
+		// 4 ( -90deg) => 11110
+		// 5 ( 135deg) => 111110
+		// 6 (-135deg) => 111111
+		// Right-friendly direction (Left start)
+		// 0 (   0deg) => 0
+		// 2 ( -45deg) => 10
+		// 1 (  45deg) => 110
+		// 4 ( -90deg) => 1110
+		// 3 (  90deg) => 11110
+		// 6 (-135deg) => 111110
+		// 5 ( 135deg) => 111111
+
+		// refer to a paper "An efficient chain code with Huffman coding"
+
+		for( UInt ui = 0; ui < uiReorderSymbol; ui++ )
+		{
+			m_pcBinIf->encodeBin( 1, m_cEdgeIntraSCModel.get( 0, 0, uiCtxEdgeIntra ) );
+		}
+
+		if( uiReorderSymbol != 6 )
+			m_pcBinIf->encodeBin( 0, m_cEdgeIntraSCModel.get( 0, 0, uiCtxEdgeIntra ) );
+	}
+}
+#endif
+
 Void TEncSbac::codeIntraDirLumaAng( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
@@ -835,7 +922,15 @@
   if( pcCU->getSlice()->getSPS()->getUseDMM() && pcCU->getWidth( uiAbsPartIdx ) <= DMM_WEDGEMODEL_MAX_SIZE )
   {
-    m_pcBinIf->encodeBin( uiDir >= NUM_INTRA_MODE, m_cDmmFlagSCModel.get(0, 0, 0) );
-  }
+#if LGE_EDGE_INTRA
+	  m_pcBinIf->encodeBin( uiDir >= NUM_INTRA_MODE && uiDir < EDGE_INTRA_IDX, m_cDmmFlagSCModel.get(0, 0, 0) );
+#else
+	  m_pcBinIf->encodeBin( uiDir >= NUM_INTRA_MODE, m_cDmmFlagSCModel.get(0, 0, 0) );
+#endif
+  }
+#if LGE_EDGE_INTRA
+  if( uiDir >= NUM_INTRA_MODE && uiDir < EDGE_INTRA_IDX )
+#else
   if( uiDir >= NUM_INTRA_MODE )
+#endif
   {
     assert( pcCU->getWidth( uiAbsPartIdx ) <= DMM_WEDGEMODEL_MAX_SIZE );
@@ -870,8 +965,47 @@
   }
   else
+#if LGE_EDGE_INTRA
+	  if ( uiDir >= EDGE_INTRA_IDX)
+	  {
+		  m_pcBinIf->encodeBin( 0, m_cCUIntraPredSCModel.get( 0, 0, 0 ) );
+		  m_pcBinIf->encodeBinsEP( 63, 6 );
+		  xCodeEdgeIntraInfo( pcCU, uiAbsPartIdx );
+#if LGE_EDGE_INTRA_DELTA_DC
+		  m_pcBinIf->encodeBin( (uiDir == EDGE_INTRA_DELTA_IDX), m_cEdgeIntraDeltaDCSCModel.get(0, 0, 0) );
+		  if( uiDir == EDGE_INTRA_DELTA_IDX )
+		  {
+			  Int iDeltaDC0 = pcCU->getEdgeDeltaDC0( uiAbsPartIdx );
+			  Int iDeltaDC1 = pcCU->getEdgeDeltaDC1( uiAbsPartIdx );
+
+			  xWriteExGolombLevel( UInt( abs( iDeltaDC0 ) ), m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
+			  if ( iDeltaDC0 != 0 )
+			  {
+				  UInt uiSign = iDeltaDC0 > 0 ? 0 : 1;
+				  m_pcBinIf->encodeBinEP( uiSign );
+			  }
+			  xWriteExGolombLevel( UInt( abs( iDeltaDC1 ) ), m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
+			  if ( iDeltaDC1 != 0 )
+			  {
+				  UInt uiSign = iDeltaDC1 > 0 ? 0 : 1;
+				  m_pcBinIf->encodeBinEP( uiSign );
+			  }
+		  }
+#endif
+	  }
+	  else
+#endif // LGE_EDGE_INTRA
   {
 #endif
 #if !LOGI_INTRA_NAME_3MPM
   Int iIntraIdx = pcCU->getIntraSizeIdx(uiAbsPartIdx);
+#endif
+#if LGE_EDGE_INTRA
+  Bool bCodeEdgeIntra = false;
+  if( pcCU->getSlice()->getSPS()->isDepth() )
+  {
+	  UInt uiPUWidth = pcCU->getWidth( uiAbsPartIdx ) >> (pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_NxN ? 1 : 0);
+	  if( uiPUWidth <= LGE_EDGE_INTRA_MAX_SIZE && uiPUWidth >= LGE_EDGE_INTRA_MIN_SIZE )
+		  bCodeEdgeIntra = true;
+  }
 #endif
   
@@ -932,4 +1066,8 @@
 #if LOGI_INTRA_NAME_3MPM
     m_pcBinIf->encodeBinsEP( uiDir, 5 );
+#if LGE_EDGE_INTRA
+	if (bCodeEdgeIntra)
+		if (uiDir == 31) m_pcBinIf->encodeBinsEP(0,1);
+#endif
 #else
     if ( uiDir < 31 )
@@ -2270,5 +2408,5 @@
 }
 
-#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
+#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX || (LGE_EDGE_INTRA && LGE_EDGE_INTRA_DELTA_DC)
 Void TEncSbac::xWriteExGolombLevel( UInt uiSymbol, ContextModel& rcSCModel  )
 {
Index: branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSbac.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSbac.h	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSbac.h	(revision 97)
@@ -175,4 +175,7 @@
   Void  xCodeContourPredTexDeltaInfo( TComDataCU* pcCU, UInt uiAbsPartIdx );
 #endif
+#if LGE_EDGE_INTRA
+  Void  xCodeEdgeIntraInfo( TComDataCU* pcCU, UInt uiPartIdx );
+#endif
 
 protected:
@@ -307,4 +310,10 @@
   ContextModel3DBuffer m_cDmmDataSCModel;
 #endif
+#if LGE_EDGE_INTRA
+  ContextModel3DBuffer m_cEdgeIntraSCModel;
+#if LGE_EDGE_INTRA_DELTA_DC
+  ContextModel3DBuffer m_cEdgeIntraDeltaDCSCModel;
+#endif
+#endif
 };
 
Index: branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 97)
@@ -952,10 +952,14 @@
 Void
 TEncSearch::xIntraCodingLumaBlk( TComDataCU* pcCU,
-                                UInt        uiTrDepth,
-                                UInt        uiAbsPartIdx,
-                                TComYuv*    pcOrgYuv, 
-                                TComYuv*    pcPredYuv, 
-                                TComYuv*    pcResiYuv, 
-                                Dist&       ruiDist )
+								UInt        uiTrDepth,
+								UInt        uiAbsPartIdx,
+								TComYuv*    pcOrgYuv, 
+								TComYuv*    pcPredYuv, 
+								TComYuv*    pcResiYuv, 
+								Dist&       ruiDist 
+#if LG_ZEROINTRADEPTHRESI_M26039
+								,Bool        bZeroResi
+#endif
+								)
 {
   UInt    uiLumaPredMode    = pcCU     ->getLumaIntraDir     ( uiAbsPartIdx );
@@ -988,4 +992,21 @@
   pcCU->getPattern()->initPattern   ( pcCU, uiTrDepth, uiAbsPartIdx );
   pcCU->getPattern()->initAdiPattern( pcCU, uiAbsPartIdx, uiTrDepth, m_piYuvExt, m_iYuvExtStride, m_iYuvExtHeight, bAboveAvail, bLeftAvail );
+
+#if LGE_EDGE_INTRA
+  if( uiLumaPredMode >= EDGE_INTRA_IDX )
+  {
+#if LGE_EDGE_INTRA_DELTA_DC
+	  if( uiLumaPredMode == EDGE_INTRA_DELTA_IDX )
+		  xAssignEdgeIntraDeltaDCs( pcCU, uiAbsPartIdx, piOrg, uiStride, piPred, uiWidth, uiHeight );
+#endif
+
+	  predIntraLumaEdge( pcCU, pcCU->getPattern(), uiAbsPartIdx, uiWidth, uiHeight, piPred, uiStride
+#if LGE_EDGE_INTRA_DELTA_DC
+		  , uiLumaPredMode == EDGE_INTRA_DELTA_IDX
+#endif
+		  );
+  }
+  else
+#endif
   
   //===== get prediction signal =====
@@ -1020,4 +1041,16 @@
     }
   }
+#if LG_ZEROINTRADEPTHRESI_M26039
+  if(bZeroResi)
+  {
+	  Pel* pResi = piResi;
+
+	  for( UInt uiY = 0; uiY < uiHeight; uiY++ )
+	  {
+		  memset( pResi, 0, sizeof( Pel ) * uiWidth );
+		  pResi += uiStride;
+	  }
+  }
+#endif
   
   //===== transform and quantization =====
@@ -1300,16 +1333,20 @@
 Void 
 TEncSearch::xRecurIntraCodingQT( TComDataCU*  pcCU, 
-                                UInt         uiTrDepth,
-                                UInt         uiAbsPartIdx, 
-                                Bool         bLumaOnly,
-                                TComYuv*     pcOrgYuv, 
-                                TComYuv*     pcPredYuv, 
-                                TComYuv*     pcResiYuv, 
-                                Dist&        ruiDistY,
-                                Dist&        ruiDistC,
+								UInt         uiTrDepth,
+								UInt         uiAbsPartIdx, 
+								Bool         bLumaOnly,
+								TComYuv*     pcOrgYuv, 
+								TComYuv*     pcPredYuv, 
+								TComYuv*     pcResiYuv, 
+								Dist&        ruiDistY,
+								Dist&        ruiDistC,
 #if HHI_RQT_INTRA_SPEEDUP
-                                Bool         bCheckFirst,
-#endif
-                                Double&      dRDCost )
+								Bool         bCheckFirst,
+#endif
+								Double&      dRDCost 
+#if LG_ZEROINTRADEPTHRESI_M26039
+								,Bool         bZeroResi
+#endif
+								)
 {
   UInt    uiFullDepth   = pcCU->getDepth( 0 ) +  uiTrDepth;
@@ -1328,4 +1365,10 @@
   {
     bCheckSplit = false;
+  }
+#endif
+#if LGE_EDGE_INTRA
+  if( pcCU->getLumaIntraDir( uiAbsPartIdx ) >= EDGE_INTRA_IDX )
+  {
+	  bCheckSplit = false;
   }
 #endif
@@ -1346,5 +1389,9 @@
     //----- code luma block with given intra prediction mode and store Cbf-----
     dSingleCost   = 0.0;
-    xIntraCodingLumaBlk( pcCU, uiTrDepth, uiAbsPartIdx, pcOrgYuv, pcPredYuv, pcResiYuv, uiSingleDistY ); 
+#if LG_ZEROINTRADEPTHRESI_M26039
+	xIntraCodingLumaBlk( pcCU, uiTrDepth, uiAbsPartIdx, pcOrgYuv, pcPredYuv, pcResiYuv, uiSingleDistY, bZeroResi ); 
+#else
+	xIntraCodingLumaBlk( pcCU, uiTrDepth, uiAbsPartIdx, pcOrgYuv, pcPredYuv, pcResiYuv, uiSingleDistY ); 
+#endif
     if( bCheckSplit )
     {
@@ -1807,4 +1854,19 @@
     UInt uiRdModeList[FAST_UDI_MAX_RDMODE_NUM];
     Int numModesForFullRD = g_aucIntraModeNumFast[ uiWidthBit ];
+
+#if LGE_EDGE_INTRA
+	Bool bTestEdgeIntra = false;
+	if ( m_pcEncCfg->isDepthCoder() && uiWidth >= LGE_EDGE_INTRA_MIN_SIZE && uiWidth <= LGE_EDGE_INTRA_MAX_SIZE && uiWidth == uiHeight )
+	{
+		bTestEdgeIntra = true;
+
+		Bool bEdgeExist;
+
+		bEdgeExist = xEdgePartition( pcCU, uiPartOffset, pcCU->getPartitionSize(0) == SIZE_NxN );
+
+		if( !bEdgeExist )
+			bTestEdgeIntra = false;
+	}
+#endif
     
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
@@ -1866,4 +1928,7 @@
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
         if( bTestDmm ) bTestDmm = uiSad ? true : false;
+#endif
+#if LGE_EDGE_INTRA
+		if ( bTestEdgeIntra ) bTestEdgeIntra = uiSad ? true : false;
 #endif
       }
@@ -1974,4 +2039,13 @@
     }
 #endif
+#if LGE_EDGE_INTRA
+	if( bTestEdgeIntra )
+	{
+		uiRdModeList[ numModesForFullRD++ ] = EDGE_INTRA_IDX;
+#if LGE_EDGE_INTRA_DELTA_DC
+		uiRdModeList[ numModesForFullRD++ ] = EDGE_INTRA_DELTA_IDX;
+#endif
+	}
+#endif
 
     //===== check modes (using r-d costs) =====
@@ -1987,12 +2061,22 @@
     for( UInt uiMode = 0; uiMode < numModesForFullRD; uiMode++ )
     {
+#if LG_ZEROINTRADEPTHRESI_M26039
+		Bool bAllowZeroResi = pcCU->getSlice()->getIsDepth() && (pcCU->getSlice()->getPOC()%pcCU->getPic()->getIntraPeriod());// && (uiMode < NUM_INTRA_MODE);
+		for(UInt uiCnt = 0; uiCnt < (bAllowZeroResi ? 2 : 1); uiCnt++)
+		{
+			Bool bZeroResi = uiCnt ? true : false;
+#endif
       // set luma prediction mode
       UInt uiOrgMode = uiRdModeList[uiMode];
       
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-      if( m_pcEncCfg->getIsDepth() && !predIntraLumaDMMAvailable( uiOrgMode, uiWidth, uiHeight ) )
-      {
-        continue;
-      }
+	  if( m_pcEncCfg->getIsDepth() && !predIntraLumaDMMAvailable( uiOrgMode, uiWidth, uiHeight ) 
+#if LGE_EDGE_INTRA
+		  && uiOrgMode < EDGE_INTRA_IDX
+#endif
+		  )
+	  {
+		  continue;
+	  }
 #endif
 
@@ -2020,7 +2104,11 @@
 
 #if HHI_RQT_INTRA_SPEEDUP
-      xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, true, dPUCost );
-#else
-      xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, dPUCost );
+#if LG_ZEROINTRADEPTHRESI_M26039
+	  xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, true, dPUCost, bZeroResi );
+#else
+	  xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, true, dPUCost );
+#endif
+#else
+	  xRecurIntraCodingQT( pcCU, uiInitTrDepth, uiPartOffset, bLumaOnly, pcOrgYuv, pcPredYuv, pcResiYuv, uiPUDistY, uiPUDistC, dPUCost );
 #endif
       
@@ -2053,5 +2141,8 @@
       }
 #endif
-    } // Mode loop
+#if LG_ZEROINTRADEPTHRESI_M26039
+		}
+#endif
+	} // Mode loop
     
 #if HHI_RQT_INTRA_SPEEDUP
